<?php

declare(strict_types=1);

namespace FiloBlu\GcpLogging\Logger\Handler;

use FiloBlu\GcpLogging\Helper\Data;
use Magento\Framework\Filesystem\DriverInterface;
use Magento\Framework\Logger\Handler\Base;
use Psr\Log\LoggerInterface;

/**
 *
 */
class File extends Base
{
    /**
     * @var LoggerInterface[]
     */
    protected $loggers = [];

    /**
     * @var Data
     */
    protected $data;

    protected $fileName = '/var/log/mod2_gcp_logging.log';

    /**
     * @param Data $data
     * @param DriverInterface $filesystem
     * @param string|null $filePath
     * @param string|null $fileName
     */
    public function __construct(Data $data, DriverInterface $filesystem, ?string $filePath = null, ?string $fileName = null)
    {
        $this->data = $data;
        parent::__construct($filesystem, $filePath, $fileName);
    }


    public function isHandling(array $record): bool
    {
        return $this->data->isLoggingEnabled()
            && $this->data->getActiveLoggingType() == Data::LOG_TYPE_FILE
            && isset($record['context']['topic'])
            && $record['context']['topic'] == 'FiloBlu';
    }
}
